from clmainApp.whatsapp_sms_info import *
from clmainApp.models  import WhatsappFailedMessageSent
def send_single_wa_message(recipient,is_priority_instant,message_text):
    send_priority_code = 1 if is_priority_instant else 2
    message_obj = {
    "secret": apiSecret,
    "account": account_key_wa,
    "recipient": f"+2{recipient}",
    "priority" :send_priority_code,
    "type": "text",
    "message": message_text,
    }
    r = requests.post(url = "{}/send/whatsapp".format(base_url), data = message_obj)
    result = r.json()
    if result["status"] != 200 :
        #print(result)
        WhatsappFailedMessageSent.objects.create(wa_number=f"+2{recipient}",original_message=message_text[:100],error_msg=result["message"])
    return (True if result["status"]== 200 else False)

def sendBulkChats(campaign_name ,recipients_string,message):
    #     secret: 763cc1e2d88f01f3078a4b7cbcb05410489f4915
    # account: 17135393785f93f983524def3dca464469d2cf9f3e6622893289580
    # campaign: Sunday__21-04-2024__09_48AM__WA
    # recipients: +201030948321,+201018223004,
    # type: text
    # message: Hello World!
    chat = {
        "secret": apiSecret,
        "account": account_key_wa,
        "type": "text",
        "campaign":campaign_name,
        "recipients": recipients_string,
        "message":message,
        #"message":message+"\n {{date.now}} {{date.time}}"
    }
        #"groups": "1,2,3,4",
        #"phone": "+201001234567",
        
    #}
    # chat_hard_coded = {"secret": "763cc1e2d88f01f3078a4b7cbcb05410489f4915",
    #     "account": "17135393785f93f983524def3dca464469d2cf9f3e6622893289580",
    #     "campaign": "Sunday__21-04-2024__09_48AM__WA",
    #     "recipients": "+201030948321,+201018223004,",
    #     "type": "text",
    #     "message": "Hello World!"}
    request_url = "{}/send/whatsapp.bulk".format(base_url)
    files=[]
    #import json
    #chat_json = json.dumps(chat)
    r = requests.post(request_url, data= chat,files=files)
    result = r.json()
    status = True if result["status"]== 200 else False
    return status,result["message"],result["data"]
    #return (True if result["status"]== 200 else False)
    # {
    # "status": 200,
    # "message": "2 chats has been queued for sending!",
    # "data": false
    # }
    # {
    # "status": 400,
    # "message": "Invalid Parameters!",
    # "data": false
    # }

def startWhatsAppCampaign(campaignId):
    params_obj = {
    "secret": apiSecret,
    "campaign": campaignId
    }
    r = requests.get(url = "{}/remote/start.chats".format(base_url), params = params_obj)
    result = r.json()
    return (True if result["status"]== 200 else False)

def stopWhatsAppCampaign(campaignId):
    params_obj = {
    "secret": apiSecret,
    "campaign": campaignId
    }
    r = requests.get(url = "{}/remote/stop.chats".format(base_url), params = params_obj)
    result = r.json()
    return (True if result["status"]== 200 else False)

def deleteWhatsAppCampaign(campaignId):
    params_obj = {
    "secret": apiSecret,
    "campaign": campaignId
    }
    r = requests.get(url = "{}/delete/wa.campaign".format(base_url), params = params_obj)
    result = r.json()
    return (True if result["status"]== 200 else False)


def validate_wa_phone(phone):
    params_obj = {
    "secret": apiSecret,
    "unique": account_key_wa,
    "phone": f"+2{phone}"
    }
    r = requests.get(url = "{}/validate/whatsapp".format(base_url), params = params_obj)
    result = r.json()
    return (True if result["status"]== 200 else False)
    #if result["status"]== 200:
    '''
    {
    "status": 200,
    "message": "WhatsApp phone number is valid!",
    "data": {
        "jid": "201018223004@s.whatsapp.net",
        "phone": "+201018223004"
    }
    }

    {
    "status": 404,
    "message": "WhatsApp phone number does not exist!",
    "data": false
    }

    {
    "status": 400,
    "message": "Invalid Parameters!",
    "data": false
    }
    '''

def getWaCampaigns():
    params_obj = {
        "secret": apiSecret,
    }
    desired_account = account_number_wa
    r = requests.get(url = "{}/get/wa.campaigns".format(base_url), params = params_obj)
    result = r.json()
    status = True if result["status"]== 200 else False
    # Filter the list by the value of the 'account' key
    data = result["data"]
    filtered_data = [item for item in data if item.get('account') == desired_account]
    # get data for account_number_wa
    return status,result["message"],filtered_data
# do something with response object


'''
# your API secret from (Tools -> API Keys) page
apiSecret = "API_SECRET"

chat = {
    "secret": apiSecret,
    "account": "170305402334173cb38f07f89ddbebc2ac9128303f65828ac75f456",
    "recipient": "+201001234567",
    "type": "text",
    "message": "Hello World!"
}

r = requests.post(url = "https://king-mastar.com/api/send/whatsapp", params = chat)
    
# do something with response object
result = r.json()

'''
'''
class Command(BaseCommand):
    help = 'Check objects in the database'

    def handle(self, *args, **options):
        # Your code to check objects in the database goes here
        pv = PatientVisit.objects.last()
        apiSecret = "d74a30bc7762343d293c9e837543ee3670a1b7d4"
        chat = {
            "secret": apiSecret,
            "account": "170305402334173cb38f07f89ddbebc2ac9128303f65828ac75f456",
            "recipient": "+201155186508",
            "type": "text",
            "priority" :1,#If you want to send the message as priority, it will be sent immediately. 1 for yes and 2 for no.Default value: 2
            "message": "رقم الحجز / {} \n الاسم / {} \n الخدمة العلاجية \n {}".format(pv.id,pv.patient.fullname,pv.medicalservice.name)
        }
        #chat = { "secret": apiSecret, "account": "170305402334173cb38f07f89ddbebc2ac9128303f65828ac75f456", "recipient": "+201155186508", "type": "text", "priority" :1, "message": f"{pv.id} >> {pv.patient.fullname} >> {pv.medicalservice.name}" }
        requests.post(url = "https://king-mastar.com/api/send/whatsapp", params = chat)
        #r = requests.post(url = "https://king-mastar.com/api/send/whatsapp", params = chat)
        # do something with response object
        #result = r.json()
        #         {
        # "status": 200,
        # "message": "WhatsApp message has been queued for sending!",
        # "data": false
        # }
        #{
        # "status": 400,
        # "message": "Invalid Parameters!",
        # "data": false
        # }
        
        #for obj in objects_to_check:
            # Do something with the object
            #pass
        #self.stdout.write(self.style.SUCCESS('Successfully checked the database'))

'''



#note if campaign deleted all queued message related will be deleted also 